//
//	HIDcmd

//======================================================================
//	{|V[
//		ʃR}h 0x00`0x0f
//		PICC^[  0x10`0x1f
//		AVRC^[  0x20`0x2f
//	LSB=1()R}h́A{IɕԓpPbgԂ.
//======================================================================

//	ʃR}h
#define HIDASP_TEST           0x01	//ڑeXg
#define HIDASP_BOOT_EXIT	  0x03	//bootloadIAAvP[VN.
#define HIDASP_POKE           0x04	//[.
#define HIDASP_PEEK           0x05	//[ǂݏo.
#define HIDASP_JMP	          0x06	//wԒñvOs.

//	PICmonpR}h
#define HIDASP_SET_MODE       0x07	//f[^胂[h̎w(00=poll c0=puts c9=exit)
#define HIDASP_PAGE_ERASE	  0x08  //Flash.
#define HIDASP_KEYINPUT		  0x09	//zXg̃L[{[h𑗂.
#define HIDASP_PAGE_WRITE     0x0a	//Flash.

//  PICł͖
#define HIDASP_BOOT_RWW	      0x0b	//AvP[V̈̃R[hǂݏo.
#define HIDASP_USER_CMD		  0x0c	//[U[`̃R}hs.
#define HIDASP_GET_STRING	  0x0d	//.

//	PICC^[n (0x10`0x1f) 
//======================================================================
#define PICSPX_SETADRS24      0x10	// 24bit̃AhXTBLPTRɃZbg.
// SETADRS24 [ CMD ] [ --- ] [ADRL] [ADRH] [ADRU] 
#define PICSPX_GETDATA8L      0x11	//  8bitf[^擾.
// GETDATA8L [ CMD ] [ LEN ] [ADRL] [ADRH] [ADRU] 
#define PICSPX_SETCMD16L      0x12	// 16bitf[^.
// SETCMD16L [ CMD ] [ LEN ] [ADRL] [ADRH] [ADRU] [CMD4] [ MS ] data[32]
#define PICSPX_BITBANG        0x14	// MCLR,PGM,PGD,PGCebit𐧌䂷.
// BITBANG   [ CMD ] [ LEN ] data[60]
#define PICSPX_BITREAD        0x15	// MCLR,PGM,PGD,PGCebit𐧌䂵Aǂݎ茋ʂԂ.
// BITREAD   [ CMD ] [ LEN ] data[60]


#define PICSPX_WRITE24F       0x16	// PIC24Ff[^.
#define PICSPX_READ24F     	  0x17	// PIC24Ff[^ǂݏo.

#define HIDASP_JTAG_WRITE	  0x18	//JTAG .
#define HIDASP_JTAG_READ	  0x19	//JTAG ǂݏ.

//	.


//	AVR݃R}h(Fusion)
//======================================================================
// +0      +1      +2        +3         +35
//[ID] [HIDASP_PAGE_TX_*] [len=32] [data(32)] [ isp(4) ]
#define HIDASP_PAGE_TX        0x20	//MODE=00
#define HIDASP_PAGE_RD        0x21	//MODE=01
#define HIDASP_PAGE_TX_START  0x22	//MODE=02  ADDR .
#define HIDASP_PAGE_TX_FLUSH  0x24	//MODE=04  ] ISP
//                            0x27 ܂łPAGE_TXŎgp.

#define CMD_MASK              0xf8	//AVR݃R}ȟo}XN.
#define MODE_MASK             0x07	//AVR݃R}h̎ʃ}XN.

//	AVR݃R}h(Control)
#define HIDASP_CMD_TX         0x28	//ISPR}h4byte.
#define HIDASP_CMD_TX_1       0x29	//ISPR}h4byteāA4byte󂯎.
#define HIDASP_SET_PAGE       0x2a	//AVR̃y[WAhXZbg.
#define HIDASP_SET_STATUS     0x2b	//AVRC^[[h̐ݒ
#define HIDASP_SET_DELAY      0x2c	//SPIݒxԂ̐ݒ.
#define HIDASP_WAIT_MSEC      0x2e	//1mSPʂ̒xs.

//foCXID
#define	DEV_ID_FUSION			0x55
#define	DEV_ID_STD				0x5a
#define	DEV_ID_MEGA88			0x88
#define	DEV_ID_MEGA88_USERMODE	0x89
#define	DEV_ID_PIC				0x25
#define	DEV_ID_PIC18F14K		0x14


#define	POLL_NONE				0
#define	POLL_ANALOG				0xa0
#define	POLL_DIGITAL			0xa0
#define	POLL_PORT				0xc0
#define	POLL_PRINT				0xc1
#define	POLL_END				0xc9


/*
 * hLg

  +--------------+-------------------------------------------------------------+
  |   R}h   |  p[^              |                              |
  +--------------+-----------+-------------------------------------------------+
  |TEST          | ECHO      |          ڑ`FbNs.
  +--------------+-----------+--------+----------------------------------------+
  |SET_STATUS    | PORTD     | PORTB  | LEDs.
  +--------------+-----------+--------+----------------------------------------+
  |CMD_TX        | ISP_COMMAND[4]           | ISPR}hSoCgM
  +--------------+--------------------------+----------------------------------+
  |CMD_TX_1      | ISP_COMMAND[4]           | ISPR}hSoCgMĎM
  +--------------+-----------+--------------+----------------------------------+
  |SET_PAGE      | PAGE_MODE |   y[W[h̏ƃAhXZbg
  +--------------+-----------+-------------------------------------------------+
  |PAGE_TX       | LENGTH    |   DATA[ max 32byte ]       | y[W[h
  +--------------+-----------+-------------------------------------------------+
  |PAGE_RD       | LENGTH    |                              y[W[hǂݏo
  +--------------+-----------+-------------------------------------------------+
  |PAGE_TX_START | LENGTH    |   DATA[ max 32byte ]       | y[W[h̏ƃy[W[h
  +--------------+-----------+-------------------------------------------------+
  |PAGE_TX_FLUSH | LENGTH    |   DATA[ 32byte Œ]       | ISP_COMMAND[4]    | y[W[h݌eݎs.
  +--------------+-----------+-------------------------------------------------+
  |SET_DELAY     | delay     |   rohNbNx̐ݒ(delay=0..255).
  +--------------+-----------+------------+-------+-------+--------------------+
  |POKE          | count     | address[2] | data0 | data1 | q`l
  +--------------+-----------+------------+-------+-------+--------------------+
  |PEEK          | count     | address[2] |                 q`lǂݏo
  +--------------+-----------+-------------------------------------------------+

 *1: PAGE_TX_STARTPAGE_TX_FLUSH͂ǂPAGE_TXɑ΂CrbgȂ̂ŁA
       𕹂pPbg쐬\łB

 *2: R}hLSBPɂȂĂꍇ̓R}hsAǂݎtF[Ys܂B
       ǂݎTCÝAzXgw肳܂B

  tF[YŕԋppPbg̍\
  +--------------+-------------------------------------------------------------+
  |   R}h   |  ԋpl                                                     |
  +--------------+-----------+----------+--------------------------------------+
  |TEST          | DEV_ID    | ECHO     |           ڑ`FbN.
  +--------------+-----------+----------+---+----------------------------------+
  |CMD_TX_1      | ISP_COMMAND[4]           | ISPR}hs.
  +--------------+--------------------------+----------------------------------+
  |PAGE_RD       | DATA[ max 38byte ]       | y[W[hǂݏof[^.
  +--------------+--------------------------+----------------------------------+
  |PEEK          | DATA[ max 8 byte ]       | q`lǂݏof[^.
  +--------------+--------------------------+----------------------------------+

 *3: HID Report͐擪ɕKReportID邽߁A
       Lԋpl HID Report̂QoCgڈȍ~̈ӖƂȂ܂B

 *4: DEV_ID ݂͌̔łł́Aȉ̒l̂ǂ炩łB 
		0x55 : t[Wt@[EFA
		0x5A : t[WȂt@[EFA
       ECHO͓nꂽl̂܂ܕԂ܂.


*/
